#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/fl_draw.H>
#include <FL/Fl_PS_Printer.H>

#include<tiffio.h>
#include<stdlib.h>

#include <mpp/grabbing.h>
#include <mpp/canvas.h>
#include <mpp/mpp.h>

/*
	unsigned char * grabbing(Fl_Window *, int x, int y, int dx, int dy);
	unsigned char * grabbing(Fl_Window *);

	void grabbing(Fl_Window *, int x, int y, int dx, int dy, const char * fname, int compr=COMPRESSION_DEFLATE);
	void grabbing(Fl_Window *, const char * fname, int compr=COMPRESSION_DEFLATE);
*/

void mpp::grabbing_png(Fl_Window *w, const char * fname, int rezolution){
	const int wpoints=504;
	if ( (dynamic_cast<mpp::Canvas *>(w)))
		w=&(dynamic_cast<mpp::Canvas *>(w)->canvas_);
	FILE * f = fopen("1_q_a_z.__","w");
	if(!f) return;
	Fl_Printer * p = new Fl_PS_Printer(f, 3, (590-wpoints)/2, (792-wpoints*w->h()/w->w())/2, wpoints, wpoints*w->h()/w->w());
	p->place(w, 0, 0, wpoints, wpoints*w->h()/w->w(), FL_ALIGN_CENTER);
	mpp::lock();
	Fl_Device * c = p->set_current();
	Fl_Color color=w->color();	
	w->color(FL_WHITE);
	fl_draw(w); 
	w->color(color);		
	c->set_current();
	mpp::unlock();
	delete p;
	fclose(f); //we need close file here
	char s_tmp[256];
	char s2_tmp[256];
	sprintf(s2_tmp,"%d",rezolution);
	#ifdef WIN32	
		strcpy(s_tmp,"gswin32c.exe -dBATCH -dNOPAUSE -dEPSCrop -sDEVICE=png16m -r");
	#else
		strcpy(s_tmp,"gs -dBATCH -dNOPAUSE -dEPSCrop -sDEVICE=png16m -r");
	#endif
	strcat(s_tmp,s2_tmp);
	strcat(s_tmp," -sOutputFile=");
	strcat(s_tmp,fname);
	strcat(s_tmp," 1_q_a_z.__; rm -f 1_q_a_z.__");
	system(s_tmp);
}

void mpp::grabbing_eps(Fl_Window *w, const char * filename){
	const int wpoints=504;
	if ( (dynamic_cast<mpp::Canvas *>(w)))
		w=&(dynamic_cast<mpp::Canvas *>(w)->canvas_);
	FILE * f = fopen(filename,"w");
	if(!f) return;
	Fl_Printer * p = new Fl_PS_Printer(f, 3, (590-wpoints)/2, (792-wpoints*w->h()/w->w())/2, wpoints, wpoints*w->h()/w->w());
	p->place(w, 0, 0, wpoints, wpoints*w->h()/w->w(), FL_ALIGN_CENTER);
	mpp::lock();
	Fl_Device * c = p->set_current();
	Fl_Color color=w->color();	
	w->color(FL_WHITE);
	fl_draw(w); 
	w->color(color);		
	c->set_current();
	mpp::unlock();
	delete p;
	fclose(f); //we need close file here
}

void grabbing_(Fl_Window * win, const char * fname, int comp){
	static unsigned int csz=0;
	static unsigned char * bm=0;
	
	unsigned int dx=win->w(), dy=win->h();	
	if (csz<3*dx*dy){
		csz=3*dx*dy;
		if (bm) delete[] bm;
		bm = new unsigned char[csz];
	}
	mpp::lock();
	win->make_current();	
	fl_read_image(bm, 0, 0, dx, dy, 0);
		
	TIFF* img;

    if((img=TIFFOpen(fname,"w"))==0){
        TIFFError(0,"TIFFOpen");
    exit(1);
    }
    //TIFFSetField(img,TIFFTAG_FILLORDER,FILLORDER_LSB2MSB);
    //TIFFSetField(img,TIFFTAG_FILLORDER,FILLORDER_MSB2LSB);

    //TIFFSetField(img,TIFFTAG_PIXARLOGDATAFMT,PIXARLOGDATAFMT_8BITABGR);

    TIFFSetField(img,TIFFTAG_BITSPERSAMPLE,8);
    TIFFSetField(img,TIFFTAG_SAMPLESPERPIXEL,3);
    TIFFSetField(img,TIFFTAG_PLANARCONFIG,1);
    //TIFFSetField(img,TIFFTAG_PLANARCONFIG,PLANARCONFIG_SEPARATE);
    TIFFSetField(img,TIFFTAG_PHOTOMETRIC,PHOTOMETRIC_RGB);
    TIFFSetField(img,TIFFTAG_IMAGEWIDTH,dx);
    TIFFSetField(img,TIFFTAG_IMAGELENGTH,dy);
    TIFFSetField(img,TIFFTAG_COMPRESSION,comp);

    //TIFFSetField(img,TIFFTAG_ROWSPERSTRIP,dx);
    //TIFFSetField(img,TIFFTAG_FILLORDER,FILLORDER_MSB2LSB);

    //TIFFWriteEncodedStrip(img, 0, bm, dx*dy*3);

    for(size_t i=0; i<dy; i++)
       TIFFWriteScanline(img, bm+i*dx*3, i);
    mpp::unlock();
    TIFFClose(img);
}
